battle:
	;d'abord dfinir si c'est un combat contre un pokmon sauvage, un dresseur voire un autre joueur (par link)
	bcall _grbufclr
battle_type = $+1	;	0 = pokmon sauvage
	ld a,0
	or a
	ret nz
	ld hl,map_pokemons
	ld b,(map_pokemons_end-map_pokemons)/4
	ld de,(mapAddr)

battle_find_map_data:	; on compare l'adresse de la carte avec celle de la liste des pokmons rencontrables sur chaque carte
	push hl
	bcall _ldhlind
	or a		; \
	sbc hl,de	;  | cp hl,de
	add hl,de	; /
	pop hl
	jr z,battle_find_map_data_ok
	inc hl	; premier mot (2 octet) = adresse de la carte
	inc hl	; /
	inc hl	; deuxime mot = adresse des pokmons de la carte
	inc hl	; /
	djnz battle_find_map_data
	ret	; pas de donnes concernant les pokmons rencontrables sur la carte donc pas de combat...

battle_find_map_data_ok:
	inc hl
	inc hl
	bcall _ldhlind	; on a les donnes des pokmons (ID et amplitudes des niveaux)
	ld a,(hl)	; nombre maximum de pokmons
	ld b,a
	call ionRandom
	ld d,0
	ld e,a	; on en choisit un au hasard (faudrait peut tre grer la raret ?)
	inc hl	; premier pokmon
	add hl,de	; ou plus
	add hl,de	;  |
	add hl,de	; /
	ld a,(hl)
	ld (opponent_pokemon_stats),a	; on a l'ID du pokmon, maintenant faut tirer un niveau au hasard
	inc hl
	push hl	; niveau min
	inc hl
	ld a,(hl)	; niveau max
	ld b,a
	call ionRandom
	pop hl
	ld b,a
	ld a,(hl)
	add a,b
	ld (opponent_pokemon_stats+1),a	; on a son niveau

battle_disp:
	bcall _grbufclr
	call battle_draw_player_back
	call battle_draw_frame
	ld hl,opponent_pokemon_stats
	call find_pokemon_data
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de	; l on en est  son nom
	ld e,40/8*26	; taille de la sprite
	; penser  sauter les volutions !!!!!
	add hl,de	; maintenant on ses PV
	inc hl
	ld a,(hl)
	ld (opponent_pokemon_stats+2),a
	ld (opponent_pokemon_stats+3),a
	; etc... (penser  tout copier/crer)
	ld hl,opponent_pokemon_stats
	push hl
	call battle_wild_pokemon_intro
	pop hl

battle_start:
	push hl
	call battle_player_pokemon_intro	; /!\ cette routine se termine par un fade_out
	pop hl	; ici hl=opponent pokemon stats, de=player pokemon datas
	call battle_draw_screen

battle_menu:
	; penser peut tre  rafficher le cadre
	set textwrite,(IY+sgrflags)
	xor a
	ld (menu_cursor),a
	ld (_v_mode),a
	ld hl,$3206
	ld (pencol),hl
	ld hl,battle_pokemon_str_fight
	call _vputs_ml
	ld hl,$3236
	ld (pencol),hl
	ld hl,battle_pokemon_str_pokemon
	call _vputs_ml
	ld a,1
	ld (menu_max_option),a
	inc a
	ld (menu_cursor_x),a
	add a,48
	ld (menu_cursor_y),a
	ld hl,battle_menu_valid
	ld (menu_valid_addr),hl
	ld hl,menu_oncursor_nothing
	ld (menu_cancel_addr),hl	; pour l'instant
	ld hl,menu_oncursor_nothing
	ld (menu_oncursor_call_addr),hl
	ld hl,battle_menu_left
	ld (menu_left_addr),hl
	ld hl,battle_menu_right
	ld (menu_right_addr),hl
	call draw_menu_cursor
	call fade_in
	jp menu_handle

battle_menu_valid:
	ld a,(menu_cursor)
	or a
	jp nz,battle_menu_valid_second_line
	ld a,(menu_cursor_x)
	cp 2
	jr z,battle_menu_fight

battle_menu_pokemon:
	ret

battle_menu_fight:
	xor a
	ld (battle_menu_fight_choices),a
	call battle_draw_frame
current_pokemon_id = $+1
	ld a,0
	call find_pokemon_stats_a
	ld de,pokemon_attacks-pokemon_stats
	add hl,de
	ld a,(hl)
	ld (first_attack_id),a
	ld b,4

battle_menu_fight_loop:
	push bc
	push hl
	ld de,$3206
	ld (pencol),de
	ld a,b
	cp 1
	call z,battle_menu_fight_disp_fourth_attack
	cp 2
	call z,battle_menu_fight_disp_third_attack
	cp 3
	call z,battle_menu_fight_disp_second_attack
	call battle_menu_fight_disp_attack
	ld a,(battle_menu_fight_choices)
	inc a
	ld (battle_menu_fight_choices),a
	pop hl
	pop bc
	inc hl
	inc hl
	inc hl
	ld a,(hl)
	or a
	jr z,battle_menu_fight_skip
	djnz battle_menu_fight_loop

battle_menu_fight_skip:
	ld a,(battle_menu_fight_choices)
	srl a
	or a
	jr z,battle_menu_fight_skip2
	dec a

battle_menu_fight_skip2:
	ld (menu_max_option),a
	ld hl,battle_menu_fight_valid
	ld (menu_valid_addr),hl
	ld hl,menu_oncursor_nothing
	ld (menu_cancel_addr),hl	; penser  revenir au menu d'avant (il faudra pouvoir virer le fade_in)
	ld hl,battle_menu_fight_disp_pp
	ld (menu_oncursor_call_addr),hl
	ld hl,battle_menu_left
	ld (menu_left_addr),hl
	ld hl,battle_menu_fight_right
	ld (menu_right_addr),hl
	call draw_menu_cursor
	jp menu_handle

battle_menu_fight_disp_second_attack:
	push af
	ld a,(hl)
	ld (second_attack_id),a
	ld de,$3236
	ld (pencol),de
	pop af
	ret

battle_menu_fight_disp_third_attack:
	push af
	ld a,(hl)
	ld (third_attack_id),a
	ld de,$3806
	ld (pencol),de
	pop af
	ret

battle_menu_fight_disp_fourth_attack:
	push af
	ld a,(hl)
	ld (fourth_attack_id),a
	ld de,$3836
	ld (pencol),de
	pop af
	ret

battle_menu_fight_disp_attack:
	call find_pokemon_attack
	ld de,attack_name-attack_datas
	add hl,de
	bcall _vputs
	ret

battle_menu_fight_valid:
	; J'EN SUIS ICI <-------------------------------------------------------------------------------------------------------
	ret

battle_menu_fight_disp_pp:
	ld de,$0029
	ld hl,$5f31
	call draw_frame
	ld a,(menu_cursor)
	or a
	jp nz,battle_menu_fight_second_line
	ld a,(menu_cursor_x)
	cp 2
	jr nz,battle_menu_fight_second_attack
first_attack_id = $+1
	ld a,0
	jr battle_menu_fight_next

battle_menu_fight_second_attack:
second_attack_id = $+1
	ld a,0
	jr battle_menu_fight_next

battle_menu_fight_second_line:
	ld a,(menu_cursor_x)
	cp 2
	jr nz,battle_menu_fight_fourth_attack
third_attack_id = $+1
	ld a,0
	jr battle_menu_fight_next

battle_menu_fight_fourth_attack:
fourth_attack_id = $+1
	ld a,0

battle_menu_fight_next:
	push af
	call find_pokemon_attack_a
	call find_type
	ld a,(hl)	; ce qui suit c'est pour rcuprer le nom du type (j'en ferais peut tre une routine)
	ld d,0
	ld e,a
	add hl,de
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de
	ld de,$2a02
	ld (pencol),de
	bcall _vputs
	ld a,(current_pokemon_id)
	call find_pokemon_stats_a
	ld d,0
	ld e,pokemon_attacks-pokemon_stats
	add hl,de
	pop af
	ld b,4
	ld c,a

battle_menu_fight_pp_loop:	; j'en ferai peut tre une routine
	ld a,(hl)
	cp c
	jr z,battle_menu_fight_pp_next
	inc hl
	inc hl
	inc hl
	djnz battle_menu_fight_pp_loop

battle_menu_fight_pp_next:
	inc hl
	push hl
	ld a,(hl)
	ld de,$2a4b
	ld (pencol),de
	call _vdispa
	ld de,$2a53
	ld (pencol),de
	ld a,$2f
	bcall _vputmap
	pop hl
	inc hl
	ld a,(hl)
	ld de,$2a57
	ld (pencol),de
	call _vdispa
	jp ionFastCopy

battle_menu_fight_right:
	ld a,(battle_menu_fight_choices)
	dec a
	or a
	ret z
	ld a,(menu_cursor_x)
	cp 50
	ret z
	add a,48
	ld (menu_cursor_x),a
	jp draw_menu_cursor
battle_menu_fight_choices = $+1
	ld a,0

battle_menu_valid_second_line:
	ld a,(menu_cursor_x)
	cp 2
	jr z,battle_menu_pack

battle_menu_run:
	ret

battle_menu_pack:
	ret

battle_menu_left:
	ld a,(menu_cursor_x)
	cp 2
	ret z
	sub 48
	ld (menu_cursor_x),a
	jp draw_menu_cursor

battle_menu_right:
	ld a,(menu_cursor_x)
	cp 50
	ret z
	add a,48
	ld (menu_cursor_x),a
	jp draw_menu_cursor

battle_wild_pokemon_intro:
	call find_pokemon_data
	push hl
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de	; on saute son nom pour avoir son sprite
	push hl
	pop ix
	push ix
	xor a
	ld bc,$1a05
	ld l,0
	push af
	push bc
	push hl
	push ix
	call ionLargeSprite
	call ionFastCopy
	pop ix
	pop hl
	pop bc
	pop af
	call ionLargeSprite
	call fade_in
	pop ix
	ld b,56

battle_wild_pokemon_intro_loop:
	push ix
	push bc
	ld a,56
	sub b
	ld bc,$1a05
	ld l,0
	push af
	push bc
	push hl
	push ix
	call ionLargeSprite
	call ionFastCopy
	pop ix
	pop hl
	pop bc
	pop af
	call ionLargeSprite
	pop bc
	pop ix
	djnz battle_wild_pokemon_intro_loop
	ld a,56
	sub b
	ld bc,$1a05
	ld l,0
	call ionLargeSprite

battle_wild_pokemon_draw_frame:
	res textwrite,(IY+sgrflags)
	call battle_draw_frame
	ld de,$3202
	ld (pencol),de
	ld hl,battle_wild_pokemon_intro1
	call _v_type
	pop hl
	inc hl
	call _v_type
	ld de,$3802
	ld (pencol),de
	ld hl,battle_wild_pokemon_intro2
	call _v_type
	call _v_disp_pause
	set textwrite,(IY+sgrflags)
	ret

battle_player_pokemon_intro:
	call battle_search_next_player_pokemon_alive	; il faut d'abord vrifier quel est le premier pokmon en vie sur les 6 qu'on porte avec nous
	ret nz	; s'il n'y en a pas : game over
	push de
	res textwrite,(IY+sgrflags)
	call battle_draw_frame
	ld de,$3202
	ld (pencol),de
	ld hl,battle_player_pokemon_intro1
	call _v_type
	ld de,$3802
	ld (pencol),de
	pop hl
	push hl
	call find_pokemon_data
	inc hl
	call _v_type
	ld hl,battle_player_pokemon_intro2
	call _v_type
	call _v_disp_pause
	set textwrite,(IY+sgrflags)
	call fade_out
	call battle_draw_player_back
	pop hl
	push hl
	call battle_draw_player_pokemon
	call battle_draw_frame
	pop de
	ret

battle_search_next_player_pokemon_alive:	; output : z:pokmon found ; nz:all pokmon dead ; de = pokmon datas
	ld de,player_pokemons
	ld b,6

battle_search_next_player_pokemon_alive_loop:
	push bc
	push de
	ld a,(de)
	or a	; vrifier qu'il y ait bien un pokmon dans l'emplacement
	jp z,battle_search_next_player_pokemon_alive_skip
	pop hl
	push hl
	call find_pokemon_stats
	inc hl
	inc hl	; vrifier s'il est en vie
	ld a,(hl)
	or a
	jp nz,battle_search_next_player_pokemon_alive_ok

battle_search_next_player_pokemon_alive_skip:
	pop de
	inc de
	pop bc
	djnz battle_search_next_player_pokemon_alive_loop
	or $80	; reset zero flag
	ret

battle_search_next_player_pokemon_alive_ok:
	dec hl
	dec hl
	ld d,h
	ld e,l
	ld a,(hl)
	ld (current_pokemon_id),a
	pop af
	pop af
	xor a	; set zero flag
	ret

battle_draw_player_back:
player_gender = $+1
	ld a,0
	or a
	jr z,battle_draw_player_man_back
	ld ix,player_woman_back
	jr battle_draw_player_next

battle_draw_player_man_back:
	ld ix,player_man_back

battle_draw_player_next:
	xor a
	ld bc,$1a04
	ld l,23
	jp ionLargeSprite

battle_draw_player_pokemon:	; hl = player pokemon datas
	call find_pokemon_data
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de	; on saute son nom pour avoir son sprite
	push hl
	pop ix
	xor a
	ld bc,$1a05
	ld l,23
	call flip_sprite
	jp ionLargeSprite

battle_draw_screen:	; input : hl = opponent pokemon datas, de = player pokemon datas
	push de	; On s'occupe d'abord d'afficher le cadre + les donnes du pokmon adverse
	push hl
	call battle_draw_pokeball_if_already_captured
	pop hl
	push hl
	call find_pokemon_data
	inc hl
	ld de,$0002
	ld (pencol),de
	bcall _vputs	; on crit son nom
	ld hl,battle_pokemon_str_lvl
	ld de,$0a01
	ld (pencol),de
	bcall _vputs
	pop hl
	push hl
	inc hl
	push hl
	ld a,(hl)
	call _vdispa	; on crit son niveau
	pop hl
	inc hl
	push hl
	call battle_disp_opponent_pokemon_hp
	pop hl
	inc hl
	inc hl
	call battle_draw_opponent_pokemon_state
	ld bc,$1007
	push bc
	ld a,1
	ld l,7
	ld ix,battle_bar
	push ix
	call ionLargeSprite	; on affiche sa barre de vie
	pop ix
	pop bc
	; Ensuite lorsque ce sera un dresseur : afficher ses pokballs
	call flip_sprite	; on la flip horizontalement
	ld a,39
	ld l,32
	call ionLargeSprite	; puis on l'affiche de notre ct
	pop hl
	call battle_draw_opponent_pokemon_health_bar
	pop de
	;-------------------------------------------
	;  partie de l on ne s'occupe plus que de notre ct
	;-------------------------------------------
	ld h,d
	ld l,e	;  partir de l hl ne contient plus les donnes adverses mais les notres !
	push hl
	call find_pokemon_data
	inc hl
	ld de,$192c
	ld (pencol),de
	bcall _vputs	; le nom de notre pokmon
	ld hl,battle_pokemon_str_lvl
	ld de,$232b
	ld (pencol),de
	bcall _vputs
	pop hl
	push hl
	call find_pokemon_stats
	inc hl
	push hl
	ld a,(hl)
	call _vdispa	; son niveau
	pop hl
	inc hl
	push hl
	call battle_disp_player_pokemon_hp
	pop hl
	inc hl
	inc hl
	push hl
	call battle_draw_player_pokemon_state
	pop hl
	ld de,pokemon_exp-pokemon_state	; pour accder  son exprience (depuis l'tat)
	add hl,de
	call battle_draw_player_pokemon_experience_bar
	pop hl
	push hl
	call battle_draw_player_pokemon_health_bar
	call battle_draw_player_pokeballs
	call ionFastCopy
	pop hl
	ret

battle_disp_player_pokemon_hp:	;	input : hl = player pokemon HP
	push hl
	ld de,$2342
	call battle_disp_pokemon_hp
	ld de,$234e
	jr battle_disp_pokemon_hpmax

battle_disp_opponent_pokemon_hp:
	push hl
	ld de,$0a18
	call battle_disp_pokemon_hp
	ld de,$0a24

battle_disp_pokemon_hpmax:
	ld (pencol),de
	ld a,$d1
	bcall _vputmap
	pop hl
	inc hl
	ld a,(hl)
	jp _vdispa


battle_disp_pokemon_hp:
	ld (pencol),de
	ld a,(hl)
	jp _vdispa

battle_draw_player_pokemon_state:	; input : hl = player pokemon state
	ld a,(hl)
	or a
	ret z
	push af
	ld de,$1e2a
	ld hl,$2a30
	ld c,0
	call rectangle_filled
	pop af
	call battle_draw_pokemon_state
	ld de,$2a1f
	ld (pencol),de
	bcall _vputs
	ret

battle_draw_opponent_pokemon_state:	; input : hl = opponent pokemon state
	ld a,(hl)
	or a
	ret z
	push af
	ld de,$3511
	ld hl,$4117
	ld c,0
	call rectangle_filled
	pop af
	call battle_draw_pokemon_state
	ld de,$1136
	ld (pencol),de
	bcall _vputs
	ret

battle_draw_pokemon_state:
	ld hl,menu_pokemon_str_poison
	cp 2
	jr z,battle_draw_player_pokemon_state_sleep
	cp 3
	jr z,battle_draw_player_pokemon_state_para
	ret

battle_draw_player_pokemon_state_sleep:
	ld hl,menu_pokemon_str_sleep
	ret

battle_draw_player_pokemon_state_para:
	ld hl,menu_pokemon_str_para
	ret

battle_draw_player_pokemon_health_bar:	; input : hl = player pokemon datas
	call find_pokemon_stats
	call battle_draw_pokemon_health_bar
	ld c,1
	ld de,$2c21
	ld h,d
	ld l,e
	add a,h
	ld h,a
	jp rectangle_filled

battle_draw_opponent_pokemon_health_bar:	; input : hl = opponent pokemon stats
	call battle_draw_pokemon_health_bar
	ld c,1
	ld de,$0208
	ld h,d
	ld l,e
	add a,h
	ld h,a
	jp rectangle_filled

battle_draw_pokemon_health_bar:	; input : hl = pokemon datas
	inc hl
	inc hl
	ld a,50
	jp calculate_proportionality

battle_draw_player_pokemon_experience_bar:	; input : hl = pokemon experience
	ld a,44
	call calculate_proportionality
	ld c,1
	ld de,$312e
	ld h,d
	ld l,e
	add a,h
	ld h,a
	jp rectangle_filled

battle_draw_pokeball_if_already_captured:	; input : hl=id
	ld a,(hl)
	call is_already_captured
	ret nz
	ld a,4
	ld l,17
	ld b,4
	ld ix,pokeball_pokemon_alread_captured
	jp ionPutSprite

battle_draw_player_pokeballs:
	xor a
	ld (battle_draw_player_pokeballs_count),a
	ld hl,player_pokemons
	ld b,6

battle_draw_player_pokeballs_loop:
	ld a,(hl)
	or a
	jr z,battle_draw_player_pokeballs_skip
	push bc
	push hl
	call find_pokemon_stats
	ld ix,pokeball_pokemon_alive
	inc hl
	inc hl
	ld a,(hl)
	or a
	call z,battle_draw_player_pokeball_dead
	ld a,49
battle_draw_player_pokeballs_count = $+1
	ld c,0
	add a,c
	add a,c
	add a,c
	add a,c
	ld l,42
	ld b,3
	call ionPutSprite
	ld a,(battle_draw_player_pokeballs_count)
	inc a
	ld (battle_draw_player_pokeballs_count),a
	pop hl
	pop bc
	inc hl
	djnz battle_draw_player_pokeballs_loop
	ret

battle_draw_player_pokeball_dead:
	ld ix,pokeball_pokemon_dead
	ret

battle_draw_player_pokeballs_skip:
	inc hl
	djnz battle_draw_player_pokeballs_loop
	ret

battle_draw_frame:
	ld de,$0031
	ld hl,$5f3f
	call draw_frame
	jp ionFastCopy

opponent_pokemon_stats:	; ID, lvl, PV, PVmax, state (0=normal; 1=poison; 2=sleep; 3=para), ATT, DEF, (Attack ID, PP, PPmax)*4
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
opponent_pokemon_stats_lenght:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

opponent_pokemon_lvl:	; en attendant de s'en servir
	.db 0