XIncludeFile "init.pbi"

Procedure Init()
  UsePNGImageDecoder()

  If OpenWindow(#Window, 0, 0, #WINDOW_WIDTH, #WINDOW_HEIGHT, "Pokmon map editor", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget | #PB_Window_ScreenCentered | #PB_Window_TitleBar)=0
    MessageRequester("OpenWindow() error", "Can't open editor.")
    End
  EndIf

  WindowBounds(#Window, #WINDOW_WIDTH, #WINDOW_HEIGHT, #PB_Ignore, #PB_Ignore) 

  If CreateImageMenu(#Menu, WindowID(#Window), #PB_Menu_ModernLook)
    MenuTitle("Fichier")
      MenuItem(#Nouveau,"New")
      MenuItem(#Ouvrir,"Open...")
      MenuItem(#Enregistrer,"Save")
      MenuItem(#Enregistrer_sous,"Save as...")
      MenuItem(#Exporter,"Export...")
      MenuItem(#Fermer,"Close")
      MenuBar()
      MenuItem(#Quitter,"Quit")
    MenuTitle("Outils")
      MenuItem(#Grille, "Grid")
      MenuItem(#Parametres,"Parameters")
      MenuItem(#Screenshot,"Screenshot")
    MenuTitle("Aide")
      MenuItem(#A_propos,"About...")
      DisableMenuItem(#Menu, #Enregistrer, 1)
      DisableMenuItem(#Menu, #Enregistrer_sous, 1)
      DisableMenuItem(#Menu, #Exporter, 1)
      DisableMenuItem(#Menu, #Fermer, 1)
      DisableMenuItem(#Menu, #Grille, 1)
      DisableMenuItem(#Menu, #Parametres, 1)
      DisableMenuItem(#Menu, #Screenshot, 1)
  EndIf

  If CreateToolBar(#ToolBar, WindowID(#Window))
    ToolBarImageButton(#Nouveau, ImageID(CatchImage(#PB_Any, ?New_icon)))
    ToolBarImageButton(#Ouvrir, ImageID(CatchImage(#PB_Any, ?Open_icon)))
    ToolBarImageButton(#Enregistrer, ImageID(CatchImage(#PB_Any, ?Save_icon)))
    ToolBarSeparator()
    ToolBarImageButton(#Pen, ImageID(CatchImage(#PB_Any, ?Pen_icon)), #PB_ToolBar_Toggle)
    ToolBarImageButton(#Square, ImageID(CatchImage(#PB_Any, ?Square_icon)), #PB_ToolBar_Toggle)
    ToolBarImageButton(#Fill, ImageID(CatchImage(#PB_Any, ?Fill_icon)), #PB_ToolBar_Toggle)
    ToolBarSeparator()
    ToolBarImageButton(#Zoom1, ImageID(CatchImage(#PB_Any, ?Zoom1_icon)), #PB_ToolBar_Toggle)
    ToolBarImageButton(#Zoom2, ImageID(CatchImage(#PB_Any, ?Zoom2_icon)), #PB_ToolBar_Toggle)
    ToolBarSeparator()
    ToolBarImageButton(#Exporter, ImageID(CatchImage(#PB_Any, ?Triangle_icon)))
    ToolBarToolTip(#ToolBar, #Nouveau, "New")
    ToolBarToolTip(#ToolBar, #Ouvrir, "Open...")
    ToolBarToolTip(#ToolBar, #Enregistrer, "Save")
    ToolBarToolTip(#ToolBar, #Pen, "Pen")
    ToolBarToolTip(#ToolBar, #Square, "Square")
    ToolBarToolTip(#ToolBar, #Fill, "Fill")
    ToolBarToolTip(#ToolBar, #Zoom1, "Zoom *1")
    ToolBarToolTip(#ToolBar, #Zoom2, "Zoom *2")
    ToolBarToolTip(#ToolBar, #Exporter, "Export to .83p and .8xp")
    DisableToolBarButton(#ToolBar, #Enregistrer, 1)
    DisableToolBarButton(#ToolBar, #Pen, 1)
    DisableToolBarButton(#ToolBar, #Square, 1)
    DisableToolBarButton(#ToolBar, #Fill, 1)
    DisableToolBarButton(#ToolBar, #Zoom1, 1)
    DisableToolBarButton(#ToolBar, #Zoom2, 1)
    DisableToolBarButton(#ToolBar, #Exporter, 1)
  EndIf

  If CreateStatusBar(#StatusBar, WindowID(#Window))
    AddStatusBarField(#PB_Ignore)
  EndIf
  
  CatchImage(#TilesImage, ?Tiles)
EndProcedure

Procedure InitWorkArea()
  CreateImage(#MapImage, map_\w*#TILE_WIDTH, map_\h*#TILE_HEIGHT)

  DisableMenuItem(#Menu, #Enregistrer_sous, 0)
  DisableMenuItem(#Menu, #Exporter, 0)
  DisableMenuItem(#Menu, #Fermer, 0)
  DisableMenuItem(#Menu, #Grille, 0)
  DisableMenuItem(#Menu, #Parametres, 0)
  DisableMenuItem(#Menu, #Screenshot, 0)
  DisableToolBarButton(#ToolBar, #Pen, 0)
  DisableToolBarButton(#ToolBar, #Square, 0)
  DisableToolBarButton(#ToolBar, #Fill, 0)
  DisableToolBarButton(#ToolBar, #Zoom1, 0)
  DisableToolBarButton(#ToolBar, #Zoom2, 0)
  DisableToolBarButton(#ToolBar, #Exporter, 0)
  SetToolBarButtonState(#ToolBar, #Pen, 1)
  SetToolBarButtonState(#ToolBar, #Zoom1, 1)
  tool = 1
  zoom = 1
  grid = 0

  UseGadgetList(WindowID(#Window))
  
  ScrollAreaGadget(#TilesScrollArea, #TilesScrollArea_x, #TilesScrollArea_y, #TilesScrollArea_w, #TilesScrollArea_h, ImageWidth(#TilesImage)*#TILES_ZOOM, ImageHeight(#TilesImage)*#TILES_ZOOM, 1, #PB_ScrollArea_Single)
    CanvasGadget(#TilesGadget, 0, 0, ImageWidth(#TilesImage)*#TILES_ZOOM, ImageHeight(#TilesImage)*#TILES_ZOOM) 
  CloseGadgetList()  

  ScrollAreaGadget(#MapScrollArea, #MapScrollArea_x, #MapScrollArea_y, WindowWidth(#Window)-#MapScrollArea_x-1, WindowHeight(#Window)-#MapScrollArea_y-44, ImageWidth(#MapImage), ImageHeight(#MapImage), 1, #PB_ScrollArea_Single|#PB_ScrollArea_Center)
    CanvasGadget(#MapGadget, 0, 0, ImageWidth(#MapImage), ImageHeight(#MapImage))
  CloseGadgetList()

  ProcedureReturn 1
EndProcedure

DataSection
New_icon:
  IncludeBinary "icons/new.ico"
Open_icon:
  IncludeBinary "icons/open.ico"
Save_icon:
  IncludeBinary "icons/save.ico"
Pen_icon:
  IncludeBinary "icons/pen.ico"
Square_icon:
  IncludeBinary "icons/square.ico"
Fill_icon:
  IncludeBinary "icons/fill.ico"
Zoom1_icon:
  IncludeBinary "icons/zoom1.ico"
Zoom2_icon:
  IncludeBinary "icons/zoom2.ico"
Triangle_icon:
  IncludeBinary "icons/triangle.ico"
Tiles:
  IncludeBinary "tiles/tiles.bmp"
EndDataSection
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 69
; FirstLine = 58
; Folding = -