EnableExplicit
XIncludeFile "main.pbi"
Init()
Main()
End

Procedure Main()
  If CountProgramParameters() > 0
    Open(ProgramParameter())
    If isset > 0
      InitWorkArea()
      HandleTiles()
      HandleMap()
    EndIf
  EndIf
  Protected event.l, quit.l = 0, ans.l, file.s, map_path.s = "map\", filterM.s = "Carte (*.map)|*.map", mapx_path.s = "map\", filterMx.s = "z80 (*.z80)|*.z80", x.l, y.l, ok.l = 0
  Repeat
    Repeat
      event = WindowEvent()
      If EventWindow() = #Window
        Select event
          Case #PB_Event_Menu
            drawing_allowed = 0
            Select EventMenu()
              Case #Nouveau
                If isset = 1
                  ans = MessageRequester("Error", "Current map isn't saved, do it now ?", #PB_MessageRequester_YesNoCancel)
                  If ans <> #PB_MessageRequester_Cancel
                    If ans = #PB_MessageRequester_Yes
                      If map_\file <> ""
                        Save(map_\file)
                      Else
                        SaveRequester(SaveFileRequester("Save as...", map_path, filterM, 0))
                      EndIf
                    EndIf
                    New()
                  EndIf
                Else
                  New()
                EndIf
                If isset > 0
                  InitWorkArea()
                  HandleTiles()
                  HandleMap()
                EndIf
              Case #Ouvrir
                file = OpenFileRequester("Open...", map_path, filterM, 0)
                If file
                  If FileSize(file) > 0
                    If isset = 1
                      If MessageRequester("Error", "Current map isn't saved. Do it now ?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                        SaveRequester(SaveFileRequester("Save as...", map_path, filterM, 0))
                      EndIf
                    EndIf
                    Open(file)
                    If isset > 0
                      Close()
                      isset = 2
                      InitWorkArea()
                      HandleTiles()
                      HandleMap()
                    EndIf
                  Else
                    MessageRequester("Erreur FileSize()", "Impossible d'ouvrir le fichier.")
                  EndIf
                EndIf
              Case #Enregistrer
                If map_\file <> ""
                  Save(map_\file)
                Else
                  SaveRequester(SaveFileRequester("Save as...", map_path, filterM, 0))
                EndIf
              Case #Enregistrer_sous
                SaveRequester(SaveFileRequester("Save as...", map_path, filterM, 0))
              Case #Exporter
                ExportRequester(SaveFileRequester("Export as...", mapx_path, filterMx, 0))
              Case #Zoom1
                zoom = 1
                SetToolBarButtonState(#ToolBar, #Zoom1, 1)
                SetToolBarButtonState(#ToolBar, #Zoom2, 0)
                SetGadgetAttribute(#MapScrollArea, #PB_ScrollArea_InnerWidth, map_\w*#TILE_WIDTH*zoom)
                SetGadgetAttribute(#MapScrollArea, #PB_ScrollArea_InnerHeight, map_\h*#TILE_HEIGHT*zoom)
                ResizeGadget(#MapGadget, #PB_Ignore, #PB_Ignore, map_\w*#TILE_WIDTH*zoom, map_\h*#TILE_HEIGHT*zoom)
                RefreshMap()
              Case #Zoom2
                zoom = 2
                SetToolBarButtonState(#ToolBar, #Zoom1, 0)
                SetToolBarButtonState(#ToolBar, #Zoom2, 1)
                SetGadgetAttribute(#MapScrollArea, #PB_ScrollArea_InnerWidth, map_\w*#TILE_WIDTH*zoom)
                SetGadgetAttribute(#MapScrollArea, #PB_ScrollArea_InnerHeight, map_\h*#TILE_HEIGHT*zoom)
                ResizeGadget(#MapGadget, #PB_Ignore, #PB_Ignore, map_\w*#TILE_WIDTH*zoom, map_\h*#TILE_HEIGHT*zoom)
                RefreshMap()
              Case #Fermer
                If isset = 1
                  If MessageRequester("Error", "Current map isn't saved. Do it now ?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                    If map_\file <> ""
                      Save(map_\file)
                    Else
                      SaveRequester(SaveFileRequester("Save as...", map_path, filterM, 0))
                    EndIf
                  EndIf
                EndIf
                Close()
                isset = 0
              Case #Quitter
                quit = 1
              Case #Grille
                grid+1
                If grid = 2
                  grid = 0
                EndIf
                SetMenuItemState(#Menu, #Grille, grid)
                RefreshMap()
              Case #A_propos
                MessageRequester("A propos...", "Editeur de carte cr par deeph (2010)")
              Case #Pen
                SetToolBarButtonState(#ToolBar, #Pen, 1)
                SetToolBarButtonState(#ToolBar, #Square, 0)
                SetToolBarButtonState(#ToolBar, #Fill, 0)
                tool = 1
              Case #Square
                SetToolBarButtonState(#ToolBar, #Pen, 0)
                SetToolBarButtonState(#ToolBar, #Square, 1)
                SetToolBarButtonState(#ToolBar, #Fill, 0)
                tool = 2
              Case #Fill
                SetToolBarButtonState(#ToolBar, #Pen, 0)
                SetToolBarButtonState(#ToolBar, #Square, 0)
                SetToolBarButtonState(#ToolBar, #Fill, 1)
                tool = 3
            EndSelect
          Case #PB_Event_Gadget
            Select EventGadget()
              Case #MapGadget
                Select EventType()
                  Case #PB_EventType_MouseEnter
                    drawing_allowed = 1
                  Case #PB_EventType_MouseLeave
                    drawing_allowed = 0
                EndSelect
                MapEvent(event)
              Case #TilesGadget
                Select EventType()
                  Case #PB_EventType_MouseEnter
                    drawing_allowed = 1
                  Case #PB_EventType_MouseLeave
                    drawing_allowed = 0
                EndSelect
                TilesEvent(event)
            EndSelect
          Case #PB_Event_SizeWindow
            drawing_allowed = 0
            If isset > 0
              ResizeGadget(#TilesScrollArea, #TilesScrollArea_x, #TilesScrollArea_y, #TilesScrollArea_w, WindowHeight(#Window)-#TilesScrollArea_y-44)
              ResizeGadget(#MapScrollArea, #MapScrollArea_x, #MapScrollArea_y, WindowWidth(#Window)-#MapScrollArea_x-1, WindowHeight(#Window)-#MapScrollArea_y-44)
            EndIf
          Case #PB_Event_CloseWindow
            quit = 1
          Case #PB_Event_ActivateWindow
            drawing_allowed = 0
        EndSelect
        If isset = 1
          DisableMenuItem(#Menu, #Enregistrer, 0)
          DisableToolBarButton(#ToolBar, #Enregistrer, 0)
        ElseIf isset = 2
          DisableMenuItem(#Menu, #Enregistrer, 1)
          DisableToolBarButton(#ToolBar, #Enregistrer, 1)
        EndIf
      EndIf
    Until event = 0
    Delay(10)
  Until quit
  If isset = 1
    If isset = 1
      If MessageRequester("Error", "Current map isn't saved. Do it now ?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
        If map_\file <> ""
          Save(map_\file)
        Else
          SaveRequester(SaveFileRequester("Save as...", map_path, filterM, 0))
        EndIf
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure Close()
  DisableMenuItem(#Menu, #Enregistrer, 1)
  DisableMenuItem(#Menu, #Enregistrer_sous, 1)
  DisableMenuItem(#Menu, #Exporter, 1)
  DisableMenuItem(#Menu, #Fermer, 1)
  DisableMenuItem(#Menu, #Grille, 1)
  DisableMenuItem(#Menu, #Parametres, 1)
  DisableMenuItem(#Menu, #Screenshot, 1)
  DisableToolBarButton(#ToolBar, #Enregistrer, 1)
  DisableToolBarButton(#ToolBar, #Pen, 1)
  DisableToolBarButton(#ToolBar, #Square, 1)
  DisableToolBarButton(#ToolBar, #Fill, 1)
  DisableToolBarButton(#ToolBar, #Zoom1, 1)
  DisableToolBarButton(#ToolBar, #Zoom2, 1)
  FreeGadget(#TilesScrollArea)
  FreeGadget(#TilesGadget)
  FreeGadget(#MapScrollArea)
  FreeGadget(#MapGadget)
  isset = 0
EndProcedure
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 57
; FirstLine = 42
; Folding = -
; EnableXP
; EnableUser
; UseIcon = icons\icon.ico
; Executable = ..\Pokmon map editor.exe
; CurrentDirectory = ..\
; EnablePurifier
; IncludeVersionInfo
; VersionField0 = 0.0.1.1
; VersionField1 = 0.0.1.1
; VersionField3 = Pokmon map editor
; VersionField6 = Pokmon map editor
; VersionField9 = Copyleft
; VersionField14 = http://deeph.servhome.org
; VersionField16 = VFT_APP
; VersionField17 = 040c French (Standard)