menu:
	call fade_out
	bcall _grbufclr
	ld bc,$240c
	xor a
	ld l,a
	ld (menu_cursor),a
	ld (_v_mode),a
	ld ix,title
	call ionLargeSprite
	ld hl,$201d
	ld (pencol),hl
	ld hl,monochrome_str
	bcall _vputs
	ld hl,$2b1d
	ld (pencol),hl
	ld hl,new_load_quit_str
	call _vputs_ml
	ld a,2
	ld (menu_max_option),a
	add a,23
	ld (menu_cursor_x),a
	add a,18
	ld (menu_cursor_y),a
	ld hl,menu_valid
	ld (menu_valid_addr),hl
	ld hl,menu_handle
	ld (menu_cancel_addr),hl
	ld hl,menu_oncursor_nothing
	ld (menu_oncursor_call_addr),hl
	ld (menu_left_addr),hl
	ld (menu_right_addr),hl
	call draw_menu_cursor
	call fade_in

menu_handle:
	ld a,$fe
	out (1),a
	in a,(1)
	bit 0,a
	push af
	call z,menu_down
	pop af
	bit 1,a
	push af
menu_left_addr = $+1
	ld hl,0
	call z,jp_hl
	pop af
	bit 2,a
	push af
menu_right_addr = $+1
	ld hl,0
	call z,jp_hl
	pop af
	bit 3,a
	call z,menu_up

	ld a,$bf
	out (1),a
	in a,(1)
	bit 5,a
menu_valid_addr = $+1
	ld hl,0
	jp z,jp_hl

	ld a,$df
	out (1),a
	in a,(1)
	bit 7,a
menu_cancel_addr = $+1
	ld hl,0
	jp z,jp_hl
	jr menu_handle

draw_menu_cursor:
menu_oncursor_call_addr = $+1
	ld hl,0
	call jp_hl

draw_menu_cursor2:
	call ionFastCopy
menu_cursor_x = $+1
	ld a,0
	ld (pencol),a
menu_cursor = $+1
	ld a,0
	or a
	ld b,a
menu_cursor_y = $+1
	ld a,0
	call nz,draw_menu_cursor_inc
	ld (penrow),a
	ld a,5
	call _vputmap_onscreen
	ld b,cursor_speed
	jp wait

draw_menu_cursor_inc:
	add a,6
	djnz draw_menu_cursor_inc
	ret

menu_down:
	ld a,(menu_cursor)
menu_max_option = $+1
	cp 0
	ret z
	inc a
	ld (menu_cursor),a
	jr draw_menu_cursor

menu_up:
	ld a,(menu_cursor)
	or a
	ret z
	dec a
	ld (menu_cursor),a
	jr draw_menu_cursor

menu_valid:
	ld a,(menu_cursor)
	cp 1
	jp z,new_game
	cp 2
	ret z
	jp menu_handle

menu_start:
	call gbaRestoreMap
	ld hl,(player_direction)
	ld bc,(player_y)
	ld de,$0108
	call gbaClipSprite
	call gbaDrawMaskSprite
	ld de,$3b00
	ld hl,$5f2c
	call draw_frame
	xor a
	ld (menu_cursor),a
	ld (_v_mode),a
	ld hl,$0141
	ld (pencol),hl
	ld hl,menu_start_str
	call _vputs_ml
	ld a,1
	ld (menu_cursor_y),a
	add a,5
	ld (menu_max_option),a
	add a,55
	ld (menu_cursor_x),a
	ld hl,menu_start_valid
	ld (menu_valid_addr),hl
	ld hl,draw_map
	ld (menu_cancel_addr),hl
	ld hl,menu_oncursor_nothing
	ld (menu_oncursor_call_addr),hl
	ld (menu_left_addr),hl
	ld (menu_right_addr),hl
	call draw_menu_cursor
	jp menu_handle

menu_start_valid:
	ld a,(menu_cursor)
	cp 1
	jr z,menu_pokemon
	jp draw_map

menu_oncursor_nothing:
	ret

menu_pokemon:
	bcall _grbufclr
	xor a
	ld (menu_cursor),a	; curseur de la routine du menu  zro
	ld hl,$0001
	ld (pencol),hl
	ld hl,menu_pokemon_str_name
	bcall _vputs	; Colonne 1 = noms des pokmons
	ld hl,$0036
	ld (pencol),hl
	ld hl,menu_pokemon_str_lvl
	bcall _vputs	; Colonne 2 = niveaux des pokmons
	ld hl,$0043
	ld (pencol),hl
	ld hl,menu_pokemon_str_hp
	bcall _vputs	; Colonne 3 = points de vie des pokmons
	ld b,0
	ld hl,player_pokemons
	push hl

menu_pokemon2:	; Boucle qui se charge de "scanner" les pokmons que porte le joueur (si ID>0 alors on affiche les donnes du pokmon)
	inc b	; b = emplacement du pokmon (sur les 6 places dispo)
	ld a,(hl)
	inc hl
	or a
	jr nz,menu_pokemon2
	pop hl
	dec b
	ld a,b
	dec a
	ld (menu_max_pokemon),a	; nombre de pokmons qui seront affichs (max 6, mais pour des raisons de lecture de boucle c'est en fait 5 (on compte 0))
	ld de,$0605	; coordonne de la premire ligne des pokmons (on incrmente ensuite au fur et  mesure)

menu_disp_pokemon:
	push hl	; hl = player_pokemons
	push bc ; b = nombre d'itrations
	call find_pokemon_stats	; on veut ses statistiques personnelles mais d'abord on va afficher son nom
	push hl
	call find_pokemon_data	; on rcupre les donnes gnrales communes  tous les pokmons de la mme espce
	inc hl	; on rcupre le nom du pokmon
	ld (pencol),de
	bcall _vputs	; on l'affiche
	pop hl	; on reviens  ses stats
	inc hl	; on veut son niveau
	push hl
	push de
	ld e,54
	ld (pencol),de
	ld a,(hl)
	call _vdispa	; on affiche son niveau
	pop de
	pop hl
	inc hl
	push hl
	push de
	ld e,67
	ld (pencol),de
	ld a,(hl)
	call _vdispa
	pop de
	push de
	ld e,79
	ld (pencol),de
	ld a,$2f
	bcall _vputmap
	pop de
	pop hl
	push de
	inc hl
	ld e,83
	ld (pencol),de
	ld a,(hl)
	call _vdispa
	pop de
	ld a,d
	add a,6
	ld d,a
	pop bc
	pop hl
	inc hl
	djnz menu_disp_pokemon
menu_max_pokemon = $+1
	ld a,0
	ld (menu_max_option),a
	ld a,1
	ld (menu_cursor_x),a
	add a,5
	ld (menu_cursor_y),a
	ld hl,menu_pokemon_valid
	ld (menu_valid_addr),hl
	ld hl,menu_start
	ld (menu_cancel_addr),hl
	ld hl,menu_pokemon_disp_attack
	ld (menu_oncursor_call_addr),hl
	ld hl,menu_pokemon_left
	ld (menu_left_addr),hl
	ld hl,menu_pokemon_right
	ld (menu_right_addr),hl
	call draw_menu_cursor
	jp menu_handle

menu_pokemon_valid:
	ld a,(menu_cursor)
	or a
	jp z,menu_handle
	ld d,0
	ld e,a
	ld hl,player_pokemons
	push hl
	ld a,(hl)
	push af
	add hl,de
	ld a,(hl)
	ld b,a
	pop af
	ld (hl),a
	pop hl
	ld a,b
	ld (hl),a
	jp menu_pokemon

menu_pokemon_disp_attack:
	xor a
	ld (attack_frame),a	; comme les attaques rentrent pas toutes dans le cadre on les affiche 2 par 2 (donc 2 frames puisqu'il y en a max 4)
	ld (next_attack_frame_valid),a	; on ne sait pas s'il y aura besoin de grer l'accs  la deuxime frame donc on reset

menu_pokemon_disp_attack2:
	ld de,$002b
	ld hl,$5f3f
	call draw_frame	; on dessine le cadre
	ld a,(menu_cursor)
	ld d,0
	ld e,a
	ld hl,player_pokemons
	add hl,de
	call find_pokemon_stats
	ld de,4
	add hl,de	; on rcupre l'tat du pokmon
	push hl
	ld a,(hl)
	or a
	jr z,menu_pokemon_skip_state	; s'il n'a rien, on s'en fout
	dec a
	ld b,0
	ld c,a
	ld hl,menu_pokemon_str_states
	add hl,bc
	add hl,bc
	bcall _ldhlind
	ld de,$3802
	ld (pencol),de
	bcall _vputs	; sinon on l'affiche

menu_pokemon_skip_state:
	pop hl
	inc hl
	inc hl
	inc hl	; on rcupre la premire attaque
	ld d,0
attack_frame = $+1
	ld e,0
	add hl,de
	add hl,de
	add hl,de	; ou on saute  la troisime attaque si on est dans la deuxime frame
	ld b,2	; on affiche deux attaques
	ld de,$2602

menu_pokemon_disp_attack_loop2:
	ld a,(hl)	; on rcupre l'ID de l'attaque
	or a
	jr z,menu_pokemon_disp_attack3	; s'il n'y a pas/plus d'attaque (ID=0) on arrte l'affichage
	push bc	; on sauvegarde le compteur
	push hl	; idem pour l'adresse de l'attaque du pokmon
	push de	; idem pour les coordonnes d'affichage
	call find_pokemon_attack
	ld de,attack_name-attack_datas
	add hl,de	; on rcupre le nom de l'attaque
	pop de
	ld a,d
	add a,6
	ld d,a	; on saute une ligne
	push de
	ld (pencol),de
	bcall _vputs ; puis on l'affiche
	pop de
	pop hl
	push de
	inc hl	; on rcupre les PP ("Points de Pouvoir") de l'attaque du pokmon
	ld e,75
	ld (pencol),de
	ld a,(hl)
	push hl
	push de
	call _vdispa	; on les affiche
	pop de
	pop hl
	inc hl	; puis on fait pareil avec les PPmax
	ld e,87
	ld (pencol),de
	ld a,(hl)
	push hl
	push de
	call _vdispa	; on les affiche
	pop de
	pop hl
	ld e,83
	ld (pencol),de
	ld a,$2f
	bcall _vputmap	; affiche "/"
	inc hl	; prochaine attaque
	pop de
	pop bc
	djnz menu_pokemon_disp_attack_loop2
	ld a,(attack_frame)
	or a
	jr z,menu_pokemon_disp_attack_frame1	; si on est  la premire frame on vrifie qu'on peut accder  la deuxime

menu_pokemon_disp_attack3:
	ld a,(attack_frame)
	or a
	ret z	; s'il on est  la premire frame on arrte l
	ld de,$385b
	ld (pencol),de
	ld a,$cf
	bcall _vputmap	; sinon on affiche la flche gauche pour indiquer qu'on peut retourner  la premire frame
	ret

menu_pokemon_disp_attack_frame1:
	ld a,(hl)
	or a
	ret z	; s'il n'y a plus d'attaque on empche l'accs  la deuxime frame
	ld a,1
	ld (next_attack_frame_valid),a
	ld de,$385b
	ld (pencol),de
	ld a,5
	bcall _vputmap	; affiche la flche vers la droite
	ret

menu_pokemon_left:	; retour  la premire frame
	ld a,(attack_frame)
	or a
	ret z
	xor a
	ld (attack_frame),a
	call menu_pokemon_disp_attack2
	jp draw_menu_cursor2

menu_pokemon_right:
next_attack_frame_valid = $+1
	ld a,0
	or a
	ret z	; vrifie qu'on peut accder la deuxime frame
	ld a,(attack_frame)
	or a
	ret nz	; si on est dj dans la deuxime frame on arrte
	ld a,2
	ld (attack_frame),a	; sinon on l'indique
	call menu_pokemon_disp_attack2
	jp draw_menu_cursor2